// ********************************************************
// * 1HE VFD Clock Firmware    (c) 2009 by maltepggel.de *
// ********************************************************
// * Key / rotary decoder handler                         *
// ********************************************************

 #include "libs/vfd.h"
 #include "libs/key.h" 
 #include "libs/portdef.h"

  // --- Initialize key ports ---
  void InitKeys( void ) 
  {
   TAST_DDR_DG1 &= ~(1<<TAST_DG1);   	// Input Ok
   TAST_DDR_DG2 &= ~(1<<TAST_DG2); 	// Input Plus
   TAST_DDR_KEY &= ~(1<<TAST_KEY);	// Input Minus
   TAST_PRT_DG1 |= (1<<TAST_DG1);	// Pullup Ok
   TAST_PRT_DG2 |= (1<<TAST_DG2);	// Pullup Plus
   TAST_PRT_KEY |= (1<<TAST_KEY);	// Pullup Minus
   MCUCR |= (1<<ISC10);			// Trigger at any logical change
   GIMSK |= (1<<INT1);
   key=0;
   state = (TAST_PRG_DG2 & (1<<TAST_PIN_DG2))?1:0;
  }

  ISR(INT1_vect)
  {
   if(key==0)
     _delay_us(10);
     if( !(TAST_PRG_DG2 & (1<<TAST_PIN_DG2)) ) 
     { 
      if(state==0) { key=1; } else { key=2; }
     } else { 
      if(state==0) { key=2; } else { key=1; }      
     }
     state = (state==0)?1:0;
  }

  void CheckKeys( void )
  {
   if( !(TAST_PRG_KEY & (1<<TAST_PIN_KEY)) ) { key=3; while(!(TAST_PRG_KEY & (1<<TAST_PIN_KEY))) { } }
  }
