// ********************************************************
// * 1HE VFD Clock Firmware    (c) 2009 by maltepggel.de *
// ********************************************************
// * User interface                                       *
// ********************************************************

  #include "libs/vfd.h"
  #include "libs/key.h"
  #include "libs/ui.h"
  #include "libs/portdef.h"

  #include "libs/USI_TWI_Master.h"

  #define DS1307ADDR 0x68

  uint8_t ee_brightness EEMEM = 0;

  // BCD to decimal
  uint8_t BCDtoDEC( uint8_t wert ) 
  {
    return ((wert & 0xF0) >> 4) * 10 + (wert & 0x0F);
  }

  // Decimal to BCD
  uint8_t DECtoBCD( uint8_t wert ) 
  {
    return 16*(wert / 10) + (wert % 10);
  }

  inline void UI( void ) 
  {

    unsigned char messageBuf[12];
    uint8_t blink = 0;
    uint8_t hour = 0;
    uint8_t min = 0;
    uint8_t sec = 0;
    uint8_t screen = 0;
    uint8_t brightness = eeprom_read_byte(&ee_brightness);
    if(brightness>25) brightness = 0;
    if(brightness!=25) OCR0A=255-(brightness*10); else OCR0A=0;
    uint8_t stime = 0;

    USI_TWI_Master_Initialise();
    
     while(1)
      {
        CheckKeys();

        messageBuf[0]=(DS1307ADDR<<TWI_ADR_BITS) | (FALSE<<TWI_READ_BIT);
        messageBuf[1]=0x00;
        USI_TWI_Start_Read_Write( messageBuf, 2 );	     
        messageBuf[0]=(DS1307ADDR<<TWI_ADR_BITS) | (TRUE<<TWI_READ_BIT);
        USI_TWI_Start_Read_Write( messageBuf, 4 );

        if(sec != messageBuf[1]) 
        { 
         sec = messageBuf[1];
         if(blink==0) blink=1; else blink=0;
         if(stime!=0) stime--;
        }

        switch(screen)
        {
         case 0:
          segdata[0]=22;
          if(blink==0) 
          { 
           DisplayConvertDot(BCDtoDEC(messageBuf[3]), (void*) segdata+4, (void*) segdata+3);
          } else {
           DisplayConvert(BCDtoDEC(messageBuf[3]), (void*) segdata+4, (void*) segdata+3);
          }
          DisplayConvert(BCDtoDEC(messageBuf[2]), (void*) segdata+2, (void*) segdata+1);
          segdata[5]=0;
          switch(key)
          {
           case 1:
            if(brightness<25) brightness++;
            if(brightness!=25) OCR0A=255-(brightness*10); else OCR0A=0;
            key=0;
            screen=1;
            stime=3;
            break;
           case 2:
            if(brightness>0) brightness--;
            if(brightness!=25) OCR0A=255-(brightness*10); else OCR0A=0;
            key=0;
            screen=1;
            stime=3;
            break;
           case 3:
            hour=BCDtoDEC(messageBuf[3]);
            min=BCDtoDEC(messageBuf[2]);
            key=0;
            screen=2;
            break;
          }
          break;
         case 1:
          segdata[0]=22;
          DisplayConvert(brightness, (void*) segdata+2, (void*) segdata+1);
          segdata[3]=21;
          segdata[4]=20;
          segdata[5]=0;
          switch(key) 
          {
           case 1:
            if(brightness<25) brightness++;
            if(brightness!=25) OCR0A=255-(brightness*10); else OCR0A=0;     
            key=0;
            stime=3;
            break;
           case 2:
            if(brightness>0) brightness--;
            if(brightness!=25) OCR0A=255-(brightness*10); else OCR0A=0;
            key=0;
            stime=3;
            break;
           default:
            key=0;
            break;
          }
          if(stime==0) screen=0;
          break;
         case 2:
           segdata[0]=22;
           if(blink==0)
           {
            DisplayConvert(hour, (void*) segdata+4, (void*) segdata+3);
           } else {
            segdata[4]=22;
            segdata[3]=22;
           }
           DisplayConvert(min, (void*) segdata+2, (void*) segdata+1);
           segdata[5]=0;
           switch(key) 
           {           
            case 1:
             if(hour<23) hour++;
             key=0;
             break;
            case 2:
             if(hour>0) hour--;
             key=0;
             break;
            case 3:
             screen=3;
             key=0;
             break;
            }
           break;
         case 3:
           segdata[0]=22;
           DisplayConvert(hour, (void*) segdata+4, (void*) segdata+3);
           if(blink==0)
           {
            DisplayConvert(min, (void*) segdata+2, (void*) segdata+1);
           } else {
            segdata[2]=22;
            segdata[1]=22;
           }
           segdata[5]=0;
           switch(key) 
           {           
            case 1:
             if(min<59) min++;
             key=0;
             break;
            case 2:
             if(min>0) min--;
             key=0;
             break;
            case 3: // Save
             screen=0;
             eeprom_write_byte(&ee_brightness, brightness);
             messageBuf[0]=(DS1307ADDR<<TWI_ADR_BITS) | (FALSE<<TWI_READ_BIT);
             messageBuf[1]=0x00;
             messageBuf[2]=0x00;
             messageBuf[3]=DECtoBCD(min);
             messageBuf[4]=DECtoBCD(hour);
             messageBuf[5]=0x00;
             messageBuf[6]=0x00;
             messageBuf[7]=0x00;
             messageBuf[8]=0x10;
             USI_TWI_Start_Read_Write( messageBuf, 9 );
             key=0;
             break;
            }
           break; 

       }

      }
  }
