// ********************************************************
// * 1HE VFD Clock Firmware    (c) 2009 by maltepggel.de *
// ********************************************************
// * VFD multiplex and decoding handler                   *
// ********************************************************
// Optimized for 8MHz crystal.

  #include "libs/vfd.h"
  #include "libs/portdef.h"
  #include "libs/vfdchar.h"
  #include "libs/key.h"
  
  // --- Definition for the interrupt ---
  SIGNAL (SIG_TIMER0_OVF)
  {

    DontCare(); 						// And two unused pins
    DontCare(); 
	DontCare(); 
    DontCare(); 
	DontCare(); 
    DontCare(); 
 
    SegShiftOut( pgm_read_byte(&chartab[segdata[segcounter]]) );  // Send segment data 
	UpperDotShiftOut( segdata[5], segcounter );

    GridShiftOut( segcounter+1 );		// Send grid data+1 -> 0 enables segment 1
 
    DISP_PRT_LOAD |= (1<<DISP_LOAD);	// Pulse LOAD pin
	DISP_PRT_LOAD &= ~(1<<DISP_LOAD);  
    
	if( segcounter==0 ) segcounter=5;	// Reset to nine if zero
	segcounter--;						// And decrement the counter by one
  }

  // --- Send one empty bit to shift register ---
  void DontCare( void )
  {
   DISP_PRT_DATA &= ~(1<<DISP_DATA);
   DISP_PRT_CLK |= (1<<DISP_CLK);
   DISP_PRT_CLK &= ~(1<<DISP_CLK);
  }
  
  // --- Convert to two digits ---
  void DisplayConvert( uint8_t val, uint8_t *digit_ten, uint8_t *digit_one ) 
  {
	digit_ten[0] = ( val / 10 );
    digit_one[0] = ( val % 10 );
  }
  
  // --- Convert to two digits /w dot ---
  void DisplayConvertDot( uint8_t val, uint8_t *digit_ten, uint8_t *digit_one ) 
  {
	digit_ten[0] = ( val / 10 );
    digit_one[0] = ( val % 10 ) + 10;
  }
    
  // --- Convert weekday to text ---
  void WeekdayConvert( uint8_t val, uint8_t *digit_one, uint8_t *digit_two ) 
  {
    switch( val ) 
	{
	  case 1:
	    digit_one[0] = 32;
	    digit_two[0] = 34;
	    break;
	  case 2:
	    digit_one[0] = 23;
	    digit_two[0] = 28;
	    break;
	  case 3:
	    digit_one[0] = 32;
	    digit_two[0] = 28;
	    break;
	  case 4:
	    digit_one[0] = 23;
	    digit_two[0] = 34;
	    break;
	  case 5:
	    digit_one[0] = 25;
	    digit_two[0] = 37;
	    break;
	  case 6:
	    digit_one[0] = 38;
	    digit_two[0] = 20;
	    break;
	  case 7:
	    digit_one[0] = 38;
	    digit_two[0] = 34;
	    break;
	  default:
	    digit_one[0] = 49;
		digit_two[0] = 49;
	}
  }
 
